import config from "config";
import client from "lib/client";
import { getRandomInt } from "lib/utils";
import { dmWelcomeContent, dmAcceptedContent } from "./dm.components.ts";
import {
    Client,
    EmbedBuilder,
    type Message,
    type CacheType,
    type GuildMember,
    type Interaction,
    type OmitPartialGroupDMChannel,
} from "discord.js";

export class DmService {
    async handleInteraction(interaction: Interaction<CacheType>) {
        // todo ?
    }

    async welcomePrivate(member: GuildMember) {
        console.log("welcome private");
        try {
            await client.users.send(member, dmWelcomeContent);
        } catch (error) {
            console.error("error while sending a welcome msg:", error);
        }
    }

    async welcomePrivateTest() {
        console.log("test welcome private");
        try {
            await client.users.send(config.discord.myId, dmWelcomeContent);
        } catch (error) {
            console.error("error while sending a welcome msg:", error);
        }
    }

    async forward(message: OmitPartialGroupDMChannel<Message<boolean>>) {
        console.log("forward message");

        const context = `<@${message.author.id}> hat geschrieben: " ${message.content} "`;

        console.log(context);

        try {
            const channels = client.channels;
            const channel = channels.cache.get(config.discord.channelIdNotification);

            if (channel?.isTextBased() && channel?.isSendable()) {
                await channel.send(context);
            }
        } catch (error) {
            console.error("error while forwarding a welcome msg:", error);
        }

        //client.users.send(config.discord.myId, context);
    }

    async acceptDm(member: GuildMember) {
        console.log("acceept dm");
        try {
            await client.users.send(member, dmAcceptedContent);
        } catch (error) {
            console.error("error while sending a accept msg:", error);
        }
    }
}
