import { CronJob } from "cron";
import { GreetingService } from "actions/greeting/greeting.service";

const greetingService = new GreetingService();

new CronJob(
	"0 30 6 * * *", // cronTime
	async () => {
		console.log("good morning");
		await greetingService.greet();
	}, // onTick
	null, // onComplete
	true, // start
	"Europe/Berlin", // timeZone
);
// job.start() is optional here because of the fourth parameter set to true.

new CronJob(
	"0 30 22 * * *",
	async () => {
		console.log("good night");
		await greetingService.sleep();
	},
	null,
	true,
	"Europe/Berlin",
);

new CronJob(
	"0 0 0 1 1 *",
	async () => {
		console.log("happy new year");
		await greetingService.newYear();
	},
	null,
	true,
	"Europe/Berlin",
);